<?php
//
// Project   : asterweb (Asterisk Realtime Web Configuration)
// Written By: David Cornewell
// Purpose   : Configure asterisk's Realtime mysql configuration
//

require_once('config.inc.php');
require_once('asterwebmod.inc.php');
require_once('sipuser.php');
require_once('voicemail.php');
require_once('extensions.php');
require_once('makecall.php');
require_once('htmlutils.inc.php');
require_once("varmanager.php");
require_once('listviewctrl.php');

class AstConfSession {
	var $sid;
	var $login_user;
	var $cgi;
	var $conn;

	function AstConfSession($db_server,$db_user,$db_pass,$db_name,$adminuser,$adminpass) {
		$this->cgi = new varmanager;
		$this->conn = DBConnect($db_server,$db_user,$db_pass,$db_name);

		$this->login_user = new SipUser();

		session_start();
		$this->sid = session_id();

		if (isset($_SESSION[user_id]) && $_SESSION[user_id]!=0) {
			$id = $_SESSION[user_id];
			if ($id==-1 && $_SESSION[password]==$adminpass) {
				$this->login_user->username=$adminuser;
				$this->login_user->name=$adminuser;
				$this->login_user->id=$id;
				
			} else {
				$this->login_user->DBGet($this->conn, "WHERE id='$id'");
				if (!$this->login_user->DBNext()) {
					print "Unable to find logged in user??";
				}
				
			}
		} else {
			$password = $_REQUEST["password"];
			$username = $_REQUEST["username"];

			if ($username && $password) {
				if ($username==$adminuser && $password==$adminpass) {
					$this->login_user->username=$adminuser;
					$this->login_user->name=$adminuser;
					$this->login_user->id=-1;
					$_SESSION[user_id] = $this->login_user->id;
					$_SESSION[password] = $adminpass;
					
				} else {
					$this->login_user->DBGet($this->conn, "WHERE username='$username' AND secret='$password' ");
					if ($this->login_user->DBNext()) {
						$_SESSION[user_id] = $this->login_user->id;
					}
					
				}
			}
		}
		return;
	}
	
	function Destroy()
	{
		$this->login_user->Destroy();
		DBClose($this->conn);
		return;
	}
}

function AstConfLoginForm()
{
?>

	<form action="<?php echo $PHP_SELF ?>" method=post>

	<input type=hidden name="f" value="<?php if ($_REQUEST["f"]!="logout") print $_REQUEST["f"]; ?>">
	<table border=0 align=center cellpadding=1 cellspacing=0>
	<tr><td align=right>Username: </td><td><input type=text name="username" value=""></td></tr>
	<tr><td align=right>Password: </td><td><input type=password name="password" value=""></td></tr>
	<tr><td align=center colspan=2><input type=submit name="login_submit" value="Login"></td></tr>
	<table>
	
	</form>

<?php
}

//
// Main logic
//
$session = new AstConfSession($db_server,$db_user,$db_pass,$db_name,$adminuser,$adminpass);

if ($session->login_user->id && $_REQUEST["f"] == "getvoicemail") {

	$file=$_REQUEST["file"];

	$fsize=filesize("/var/spool/asterisk/voicemail/".$file);
	$shortfile=substr($file, strrpos($file,'/'));
	
	header("Content-Disposition: attachment; filename=$shortfile"); 
	header("Content-Type: audio/wav"); 
	header("Content-Length: ".$fsize); 
	header("Pragma: no-cache"); 
	header("Expires: 0"); 
	$fp=fopen("/var/spool/asterisk/voicemail/".$file,"r"); 
	if ($fp) {
		print fread($fp,$fsize); 
		fclose($fp);
	}
	exit(); 
}

$session->cgi->forward(array("f"));
$f = $session->cgi->var_val("f");

?>

<html>
  <head>
  	<title>Asterisk Realtime Configuration</title>
  	<link rel="stylesheet" href="asterweb.css" type="text/css">
  </head>
<body>

<table border=1 cellpadding=1 cellspacing=0 width="100%" height="100%">
<tr><td height=30 width="100%">
	<?php	include "menu.inc.php" ?>
</td></tr>

<tr><td width="100%" valign="top" align=center>

<?php

if ($session->login_user->id) {
	if ($f == "users") {
		SipUserHandler($session);
	} else if ($f == "vmail") {
		VoiceMailHandler($session);
	} else if ($f == "extensions") {
		ExtensionsHandler($session);
	} else if ($f == "makecall") {
		Ast_MakeCall($session->login_user->name, $_REQUEST["callto"]);
	} else if ($f == "showcontacts") {
		Ast_ShowContacts($session);
	} else if ($f == "logout") {
		$_SESSION[user_id] = "";
		
		print "Logged out";
		AstConfLoginForm();
	} else {
		if ( ($module=Asterwebmod_GetModule($f)) ) {
				call_user_func($module->handlerfunc, $session);
		}
//		foreach ($asterwebmods as $module) {
//			if ($f == $module->name) {
//				call_user_func($module->handlerfunc, $session);
//			}
//		}
	}
} else {
	print "<center>Please login<center>";	
	AstConfLoginForm();
}

$session->Destroy();

?>
