<?php
//
// Project   : asterweb / extensions.php
// Written By: David Cornewell
// Purpose   : Allow admin to manage extensions
//


class AstConfExtension {
	var $id;
	var $context;
	var $exten;
	var $priority;
	var $app;
	var $appdata;
	
	var $result;
	
	function AstConfExtension() 
	{
		$this->result=null;
		$this->id=null;
	}
	
	function Destroy()
	{
		if ($this->result) {
			DBFreeResult($this->result);
		}
	}
	
	function CgiGet($cgi)
	{
		$this->id		 = $cgi->var_val("id");
		$this->context	 = $cgi->var_val("context");
		$this->exten	 = $cgi->var_val("exten");
		$this->priority = $cgi->var_val("priority");
		$this->app		 = $cgi->var_val("app");
		$this->appdata	 = $cgi->var_val("appdata");
		
	}
	
	function DBGet($conn, $where)
	{
		$this->result=Extension_DBQry($conn, $where);
	}
	
	function DBNext()
	{
		if ($this->result) {
			$row = DBGetRow($this->result);
			if ($row) {
				$this->id		 = $row["id"];
				$this->context	 = $row["context"];
				$this->exten	 = $row["exten"];
				$this->priority = $row["priority"];
				$this->app		 = $row["app"];
				$this->appdata	 = $row["appdata"];
				return 1;
			}
		}
		return 0;
	}

	function DBUpdate($conn)
	{
		Extension_DBUpdate($conn, $this);
	}
	
	function DBInsert($conn)
	{
		Extension_DBInsert($conn, $this);
	}	

	function DBDelete($conn)
	{
		Extension_DBDelete($conn, $this);
	}	
}


function ExtensionsDelete($loginsession)
{
	$ext = new AstConfExtension();
	$ext->CgiGet($loginsession->cgi);
	$ext->DBDelete($loginsession->conn);
}

function ExtensionsEdit($loginsession)
{
	$ext = new AstConfExtension();
	$ext->CgiGet($loginsession->cgi);
	$ext->DBUpdate($loginsession->conn);
}

function ExtensionsAdd($loginsession)
{
	$ext = new AstConfExtension();
	$ext->CgiGet($loginsession->cgi);
	$ext->DBInsert($loginsession->conn);
}

function ExtensionsList($loginsession,$opp)
{
	if ($loginsession->login_user->id!=-1) {
		print "You do now have permission to manage extensions!";
		return;
	}

	$ext = new AstConfExtension();
	
	$context=$loginsession->cgi->var_val("s_context");
	$exten=$loginsession->cgi->var_val("s_exten");
	$id=$loginsession->cgi->var_val("id");

?>
	<br />
	<form action="<?php echo $PHP_SELF ?>" method=GET>
	<?php $loginsession->cgi->print_hidden(); ?>
	<input type=hidden name=opp id=opp value="list">
		
	<div align=center>
		Context:
		<select name="s_context" onchange="this.form.s_exten.value=''; this.form.search.click();">
		<option value="">All</option>
		<?php
			$res=DBQuery("SELECT context FROM extensions GROUP BY context ORDER BY context", $loginsession->conn);
			if ($res) {
				$row=DBGetRow($res);
				while ($row) {
					if ($context==$row["context"]) {
						print "<option value=\"".$row["context"]."\" selected=true>".$row["context"]."</option>";
					} else {
						print "<option value=\"".$row["context"]."\">".$row["context"]."</option>";
					}
					$row=DBGetRow($res);
				}
				DBFreeResult($res);
			}
		?>
		</select>
		&nbsp;
		Extension:		
		<select name="s_exten" onchange="this.form.search.click();">
		<option value="">All</option>
		<?php
			$res=DBQuery("SELECT exten FROM extensions WHERE context LIKE '$context%' GROUP BY exten ORDER BY exten", $loginsession->conn);
			if ($res) {
				$row=DBGetRow($res);
				while ($row) {
					if ($exten==$row["exten"]) {
						print "<option value=\"".$row["exten"]."\" selected=true>".$row["exten"]."</option>";
					} else {
						print "<option value=\"".$row["exten"]."\">".$row["exten"]."</option>";
					}
					$row=DBGetRow($res);
				}
				DBFreeResult($res);
			}
		?>
		</select>
		<input type=submit name="search" value="Go">
	</div>
	
	<table border=1 cellpadding=1 cellspacing=0 align=center width="98%">
	<tr class=title>
		<td colspan=6>Extensions</td>
	</tr>
	<tr class=subtitle>
		<th>Context</th>
		<th>Extension</th>
		<th>Priority</th>
		<th>App</th>
		<th>AppData</th>
		<th>Options</th>
	</tr>

<?php

	$sql="WHERE 1";
	if ($context) {
		$sql.=" AND context='$context'";
	}
	if ($exten!="") {
		$sql.=" AND exten='$exten'";
	}
	$ext->DBGet($loginsession->conn, $sql);
	
	$i=0;
	while ($ext->DBNext()) {
		if ($i%3==0) $selclass="altvalue";
		else $selclass="value";
		
		print "<tr align=center class=$selclass>";
		if ($opp=='edit' && $id==$ext->id) {
			print "<td><input type=hidden name=id value=\"$ext->id\"><input type=hidden name=save value=\"\"><input type=text name=context value=\"$ext->context\" size=15></td>\n";
			print "<td><input type=text name=exten value=\"$ext->exten\" size=10></td>\n";
			print "<td><input type=text name=priority value=\"$ext->priority\" size=3></td>\n";
			print "<td><input type=text name=app value=\"$ext->app\" size=15></td>\n";
			print "<td><input type=text name=appdata value=\"". htmlspecialchars($ext->appdata) ."\" size=60></td>\n";
			print "<td><input type=button name=\"save\" value=\"Save\" onclick=\"this.form.opp.value='edit';this.form.submit();\"></td>\n";
		} else {
			print "<td>$ext->context</td>\n";
			print "<td>$ext->exten</td>\n";
			print "<td>$ext->priority</td>\n";
			print "<td>$ext->app</td>\n";
			print "<td>$ext->appdata</td>\n";
			print "<td>\n";
			print "<a class=$selclass href=\"".$loginsession->cgi->generate_uri(0)."&amp;opp=edit&amp;id=$ext->id\">Edit</a>\n";
			print "<a class=$selclass href=\"".$loginsession->cgi->generate_uri(0)."&amp;opp=delete&amp;id=$ext->id&amp;save\">Delete</a>\n";
			print "</td>\n";
		}
		print "</tr>\n";
		$i++;
	}
	if ($opp!="edit") {
		print "<tr align=center class=$selclass>";
		print "<td><input type=text name=context value=\"$context\"></td>\n";
		print "<td><input type=text name=exten value=\"$exten\"></td>\n";
		print "<td><input type=text name=priority></td>\n";
		print "<td><input type=text name=app></td>\n";
		print "<td><input type=text name=appdata size=40></td>\n";
		print "<td><input type=button name=\"save\" value=\"Save\" onclick=\"this.form.opp.value='add';this.form.submit();\"></td>\n";
		print "</tr>\n";
	}
	
?>
	</table>
	</form>

<?php
	$ext->Destroy();
}

function ExtensionsHandler($loginsession)
{
	$opp = $loginsession->cgi->var_val("opp");
	$loginsession->cgi->forward(array("s_exten","s_context"));
	if ($opp=="add") {
		ExtensionsAdd($loginsession);
	} else if ($opp=="edit" && $loginsession->cgi->var_exists("save")) {
		ExtensionsEdit($loginsession);
		$opp="list";
	} else if ($opp=="delete" && $loginsession->cgi->var_exists("save")) {
		ExtensionsDelete($loginsession);
		$opp="list";
	}
//	$loginsession->cgi->forwardlist=array(); //unforward(array("exten","context"));
	ExtensionsList($loginsession,$opp);
	
}

?>
