<?php
//
// Project   : asterweb / voicemail.php
// Written By: David Cornewell
// Purpose   : Allow users to check voicemail
//

class AstConfVoiceMailBox {
	var $uniqueid   ;
	var $customer_id;
	var $context    ;
	var $mailbox    ;
	var $password   ;
	var $fullname   ;
	var $email      ;
	var $pager      ;
	var $stamp      ;
	var $result;
	
	function AstConfVoiceMailBox($conn, $mailbox) 
	{
		if ($mailbox && $mailbox.length>0) {
			$fields = explode('@', $mailbox);
			if ($fields[1] && $fields[1].length>0) {
				$context=$fields[1];
			} else {
				$context="default";
			}
			$this->DBGet($conn, "WHERE mailbox='$fields[0]' AND context='$context'");
			if ($this->result) $this->DBNext();
		}		
	}
	
	function Destroy()
	{
		if ($this->result) {
			DBFreeResult($this->result);
		}
	}
	
	function DBGet($conn,$where)
	{
		$this->result=VoiceMail_DBQry($conn, $where);
	}
	
	function DBNext()
	{
		if ($this->result) {
			$row = DBGetRow($this->result);
			if ($row) {
				$this->uniqueid    = $row["uniqueid"];
				$this->customer_id = $row["customer_id"];
				$this->context     = $row["context"];
				$this->mailbox     = $row["mailbox"];
				$this->password    = $row["password"];
				$this->fullname    = $row["fullname"];
				$this->email       = $row["email"];
				$this->pager       = $row["pager"];
				$this->stamp       = $row["stamp"];
				
				return true;
			}
		}
	}
}

function ASTVM_MarkOld($mailbox, $context, $movethis)
{
	if (!strstr($movethis, "Old")) {
		$highnumber=0;
		$msgolddir="/var/spool/asterisk/voicemail/".$context."/".$mailbox."/Old/";
		$dir=opendir($msgolddir);
		if ($dir) {
			while ( ($file=readdir($dir)) ) {
				if (strpos($file,".txt") !=false) {
					$number = substr($file,3,4);
					if (intval($number)>$highnumber) {
						$highnumber=intval($number);
					}
				}
			}
			$highnumber++;
			$dest = sprintf($msgolddir."msg%04d.txt", $highnumber);
			rename($movethis . ".txt", $dest);

			$dest = sprintf($msgolddir."msg%04d.wav", $highnumber);
			rename($movethis . ".wav", $dest);

			$dest = sprintf($msgolddir."msg%04d.WAV", $highnumber);
			rename($movethis . ".WAV", $dest);

			$dest = sprintf($msgolddir."msg%04d.gsm", $highnumber);
			rename($movethis . ".gsm", $dest);
			
			closedir($dir);
		}
	}
}

function ASTVM_Delete($delthis)
{

	unlink($delthis.".wav");
	unlink($delthis.".WAV");
	unlink($delthis.".txt");
	unlink($delthis.".gsm");
}

function ASTVM_ListUserMessages($session)
{
	$vm = new AstConfVoiceMailBox($session->conn, $session->login_user->mailbox);
	
	$msgdir="/var/spool/asterisk/voicemail/".$vm->context."/".$vm->mailbox."/INBOX/";
	$msgolddir="/var/spool/asterisk/voicemail/".$vm->context."/".$vm->mailbox."/Old/";

	echo "<center>";

	$opp = $session->cgi->var_val("opp");
	if ($opp=="delete") {
		$confirm=$session->cgi->var_val("confirm");
		$delthis = "/var/spool/asterisk/voicemail/". $vm->context ."/". $vm->mailbox ."/". $session->cgi->var_val("file");
		if ($confirm=="Yes") {
			ASTVM_Delete($delthis);
		} else if ($confirm=="") {
			$session->cgi->forward(array("opp"));
			print "Are you sure you want to delete: $delthis?\n";
			print "<form action=\"\" method=post>\n";
            $session->cgi->print_hidden();
			echo "<input type=submit name=confirm value=\"Yes\"> ";
			echo "<input type=submit name=confirm value=\"No\">";
			echo "<br />";
		}
	} else if ($opp=="markold") {
		$movethis = "/var/spool/asterisk/voicemail/". $vm->context ."/". $vm->mailbox ."/". $session->cgi->var_val("file");
		ASTVM_MarkOld($vm->mailbox, $vm->context, $movethis);
	}

	print "<br>";
	print "<OBJECT ID=\"MediaPlayer\" WIDTH=250 HEIGHT=45 ";
	print "CLASSID=\"CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6\" ";
	print "STANDBY=\"Loading Windows Media Player components...\" ";
	print "TYPE=\"application/x-oleobject\" ";
	print "CODEBASE=\"http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,4,7,1112\">\n";
	print "<PARAM name=\"URL\" value=\"\">\n";
	print "<EMBED TYPE=\"application/x-mplayer2\" \n";
	print "    SRC=\"\"\n";
	print "    NAME=\"MediaPlayer\"\n";
	print "    WIDTH=250\n";
	print "    HEIGHT=45>\n";
	print "</EMBED>\n";
	print "</OBJECT></center>\n";

	$dir=opendir($msgdir);
	if ($dir) {
		print "<br><table border=1 cellpadding=1 cellspacing=0 border=1 align=center width=98%>\n";
		print "<tr class=title><td colspan=5>Messages for ".$session->login_user->mailbox."</td></tr>\n";
		print "<tr class=subtitle><td>Msg</td><td>CallerId</td><td>Date</td><td>Duration</td><td>Options</td></tr>\n";

		$i=0;
		while ( ($file=readdir($dir)) ) {
			if (strpos($file,".txt") !=false) {
				$fp = fopen($msgdir.$file, "r");
				if ($fp) {
					while ( ($line=fgets($fp, 255)) ) {
						if (strpos($line,"allerid")!=false) {
							$callerid=substr($line, strpos($line,'=')+1);
						} else if (strpos($line,"rigdate")!=false) {
							$origdate=substr($line, strpos($line,'=')+1);
						} else if (strpos($line,"uration")!=false) {
							$duration=substr($line, strpos($line,'=')+1);
						}
					}
					$wavfile=substr($file,0,strpos($file,'.')) . ".wav";
					$url=$session->cgi->progname."?f=getvoicemail&amp;file=". $vm->context ."%2f". $vm->mailbox ."%2FINBOX%2F".$wavfile;
					if ($i%3==0) $selclass="altvalue";
					else $selclass="value";
					print "<tr class=$selclass>";
					print "<td>$file</td><td>$callerid</td><td>$origdate</td><td>$duration</td>";
					print "<td><a href=\"#nothing\" onclick=\"MediaPlayer.URL='$url';\" class=$selclass>Play</a> ";
					print "<a class=$selclass href=\"" .$session->cgi->progname."?f=vmail&amp;opp=delete&amp;file=INBOX%2F". substr($file,0,strpos($file,'.')) ."\">Delete</a> \n";
					print "<a class=$selclass href=\"" .$session->cgi->progname."?f=vmail&amp;opp=markold&amp;file=INBOX%2F". substr($file,0,strpos($file,'.')) ."\">Save</a></td></tr>\n";
					
					fclose($fp);
					$i++;
				}
			}
		}
		closedir($dir);
		print "</table>";
	}
	
	$dir=opendir($msgolddir);
	if ($dir) {
		print "<br><table border=1 cellpadding=1 cellspacing=0 border=1 align=center width=98%>\n";
		print "<tr class=title><td colspan=5>Old Messages for ".$session->login_user->mailbox."</td></tr>\n";
		print "<tr class=subtitle><td>Msg</td><td>CallerId</td><td>Date</td><td>Duration</td><td>Options</td></tr>\n";

		$i=0;
		while ( ($file=readdir($dir)) ) {
			if (strpos($file,".txt") !=false) {
				$fp = fopen($msgolddir.$file, "r");
				if ($fp) {
					while ( ($line=fgets($fp, 255)) ) {
						if (strpos($line,"allerid")!=false) {
							$callerid=substr($line, strpos($line,'=')+1);
						} else if (strpos($line,"rigdate")!=false) {
							$origdate=substr($line, strpos($line,'=')+1);
						} else if (strpos($line,"uration")!=false) {
							$duration=substr($line, strpos($line,'=')+1);
						}
					}
					$wavfile=substr($file,0,strpos($file,'.')) . ".wav";
					$url=$session->cgi->progname."?f=getvoicemail&amp;file=". $vm->context ."%2f". $vm->mailbox ."%2FOld%2F".$wavfile;
					if ($i%3==0) $selclass="altvalue";
					else $selclass="value";
					
					print "<tr class=$selclass>";
					print "<td>$file</td><td>$callerid</td><td>$origdate</td><td>$duration</td>";
					print "<td><a href=\"#nothing\" onclick=\"MediaPlayer.URL='$url';\" class=$selclass>Play</a> ";
					print "<a class=$selclass href=\"" .$session->cgi->progname."?f=vmail&amp;opp=delete&amp;file=Old%2F". substr($file,0,strpos($file,'.')) ."\">Delete</a></td></tr>\n";
					
					fclose($fp);
					$i++;
				}
			}
		}
		closedir($dir);
		print "</table>";
	}
	$vm->Destroy();

	echo "</center>";
}

function VoiceMailHandler($session)
{
	if ($session->login_user->id==-1) {
		print "Voicemail boxes should be managed in user section.";
	} else {
		ASTVM_ListUserMessages($session);
	}
}

?>
